## camitk 3.2.2

=== CMakeLists.txt ===
#--------------------------------------------
#
#         CamiTK Open Source CEP Set
#
#--------------------------------------------
cmake_minimum_required(VERSION 2.6)

project(camitkopensource)

# Specific to SDK: control the version (major, minor, default patch and )
set(CAMITK_PROJECT_NAME "CamiTK")
set(CAMITK_VERSION_MAJOR "3")
set(CAMITK_VERSION_MINOR "2")
set(CAMITK_VER_NICKNAME "azure") # blue, sapphire, *azure*, indigo, iris, Teal, cyan, turquoise, denim, celeste, zaffre, glaucous, ultramarine, cerulean
set(CAMITK_VERSION_PATCH "2") # patch version for packaging, change when appropriate
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to SDK: this is the SDK build
set(CAMITK_SDK_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-opensource" CACHE STRING "CEP Set Name")

# Configure CamiTK Opensource packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros)
include(CamiTKOpenSourcePackaging)
camitk_opensource_packaging()

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects
add_subdirectory(imaging)
add_subdirectory(modeling)

camitk_sub_project_validate(CEP_SET)

=== imaging/CMakeLists.txt ===
#--------------------------------------------
# Imaging extension project
#--------------------------------------------
cmake_minimum_required(VERSION 2.6)

# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

camitk_extension_project(NAME "imaging"
                         CONTACT "Celine.Fouard@imag.fr,Emmanuel.Promayon@imag.fr"
                         DESCRIPTION "This CEP is part of CamiTK Open-Source. It provides action and component extensions that are useful for processing medical imaging: the dicom and itkimage components, the itk filters and itk segmentation actions. It depends on... ITK. "
)

=== modeling/CMakeLists.txt ===
#--------------------------------------------
# Modeling extension project
#--------------------------------------------
cmake_minimum_required(VERSION 2.6)

# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

camitk_extension_project(NAME "modeling"
                         CONTACT "Celine.Fouard@imag.fr,Emmanuel.Promayon@imag.fr"
                         DESCRIPTION "The modeling CamiTK Extension Project contains all the action and component extensions that are useful for biomechanical processing. It provides the LML, PML and MML libraries, and the related components and actions."
)

=== sdk/CMakeLists.txt ===
#--------------------------------------------
#         CamiTK Extension Project
#
# You should probably NOT modify this file...
# Please edit CEPDescription.cmake instead
#--------------------------------------------

cmake_minimum_required(VERSION 2.6)

include(SDKConfig.cmake)

# Please add your project name inside the project() brackets, e.g. project(myProject)
project(${CEP_NAME})

# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# include global install of SDK
#-- camitk_global_install == install in CAMITK_DIR
if (CAMITK_SDK_BUILD)
    # if the SDK is currently being build => install in CMAKE_INSTALL_PREFIX
    add_custom_target(sdk_global_install
		# First remove the WIN32 system runtime libraries dependencies
		COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
		COMMENT "Finishing configuration for ${CMAKE_INSTALL_PREFIX}"
        # Second cmake to install
        COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
        COMMENT "Global Installation in ${CMAKE_INSTALL_PREFIX}"
        # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory 
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    )
    
else()
    # this is called from a normal CEP build => install in CAMITK_DIR
    add_custom_target(sdk_global_install
        # First cmake to redefine install prefix and remove the WIN32 system runtime libraries dependencies
        COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX:PATH=${CAMITK_DIR} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
		COMMENT "Finishing configuration for ${CAMITK_DIR}"
        # Second cmake to install
        COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
        COMMENT "Global Installation in ${CAMITK_DIR}"
        # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory 
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    )
endif()


# camitk_local_install == install in User Config directory
add_custom_target(sdk_local_install
    # First cmake to redefine install prefix
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX:PATH=${CAMITK_USER_DIR} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
	COMMENT "Finishing configuration for ${CAMITK_USER_DIR}"
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMENT "Local Installation in ${CAMITK_USER_DIR}"
    # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory 
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
)

# include CamiTK auto-documentation generation
include(CamiTKApiDoc)

# initialize subproject management
camitk_sub_project_init()

# add all subprojects
camitk_add_subdirectory(libraries)
camitk_add_subdirectory(components)
camitk_add_subdirectory(actions)
camitk_add_subdirectory(viewers)
camitk_add_subdirectory(applications)
add_subdirectory(cmake) # for cmake module installation

# Validate project.xml file for CDash
camitk_sub_project_validate()



message(STATUS "compiling in ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CFG_INTDIR=${CMAKE_CFG_INTDIR}")
message(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

=== imaging/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro apropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  add_subdirectory(${ACTION_NAME})
endforeach()

=== imaging/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro apropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)

# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   add_subdirectory(${APPLICATION_NAME})
endforeach()

=== imaging/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# Inform the user he has the choice of the DICOM component, by default uses the incomplete ITK one
# Complete dicomdirectory and dicomimage ones require GDCM library
option(CAMITK_DICOM_INCOMPLETE_SUPPORT "Use incomplete support of DICOM images via ITK" TRUE)

if (NOT CAMITK_DICOM_INCOMPLETE_SUPPORT)
    add_subdirectory(dicomdirectory)
    add_subdirectory(dicomimage)
else()
    message(WARNING "CAMITK_DICOM_INCOMPLETE_SUPPORT: This configuration uses the legacy dicom component (directly based on ITK). The CamiTK recommands using the new dicomdirectory and dicomimage components (which require/depend on GDCM library)")
    add_subdirectory(dicom)
endif() 

# TODO restore when dicom component would have been replaced by new ones (using GDCM)
# find components
# get_subdirectories(COMPONENTS_LIST)

# Add subdirectories in CMake project
# foreach(COMPONENT_NAME ${COMPONENTS_LIST})
#   add_subdirectory(${COMPONENT_NAME})
# endforeach()

add_subdirectory(itkimage)

=== modeling/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# find components
get_subdirectories(COMPONENTS_LIST)

# Add subdirectories in CMake project
foreach(COMPONENT_NAME ${COMPONENTS_LIST})
  add_subdirectory(${COMPONENT_NAME})
endforeach()

=== sdk/cmake/CMakeLists.txt ===
#
# cmake module CMakeList.txt
#
set(CAMITK_CMAKE_PATH "share/${CAMITK_SHORT_VERSION_STRING}/cmake")

# install CamiTK configuration file
install(FILES ${CMAKE_BINARY_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake/CamiTKConfig.cmake
        DESTINATION ${CAMITK_CMAKE_PATH}
        # COMPONENT cmake-modules)
        )
        
# install the generic cmake files
file(GLOB CAMITK_CMAKE_FILES "modules/*.cmake")
install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${CAMITK_CMAKE_PATH}
        # COMPONENT cmake-modules)
        )
        
# install the macros 
file(GLOB CAMITK_CMAKE_FILES "modules/macros/*.cmake")
install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${CAMITK_CMAKE_PATH}/macros
        # COMPONENT cmake-modules)
        )
        
# install launcher-templates
file(GLOB CAMITK_CMAKE_FILES "modules/launcher-templates/*.in")
install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${CAMITK_CMAKE_PATH}/launcher-templates
        # COMPONENT cmake-modules)
        )
        
# Save the compiler settings so another project can import them.
include(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
cmake_export_build_settings(${CMAKE_CURRENT_BINARY_DIR}/../CamiTKBuildSettings.cmake)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/../CamiTKBuildSettings.cmake"
        DESTINATION ${CAMITK_CMAKE_PATH}
        # COMPONENT cmake-modules)
        )

=== sdk/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# find components
get_subdirectories(COMPONENTS_LIST)

# Add subdirectories in CMake project
foreach(COMPONENT_NAME ${COMPONENTS_LIST})
  add_subdirectory(${COMPONENT_NAME})
endforeach()

=== imaging/actions/itkfilters/CMakeLists.txt ===
if (WIN32)
	if(CMAKE_CL_64)
		# for 64 bits platform, enable big obj (.o) handling, in ordere to correctly compile this (heavy) project
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}/bigobj")
	endif()
endif()

camitk_extension(
                    ACTION_EXTENSION
                    NEEDS_ITK
                    LIBRARIES ITKBasicFilters ITKCommon ITKIO
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing filters"
)

=== imaging/actions/itksegmentation/CMakeLists.txt ===
camitk_extension(
                    ACTION_EXTENSION
                    NEEDS_ITK
                    NEEDS_ACTION_EXTENSION multipicking
                    LIBRARIES ITKBasicFilters ITKCommon ITKIO
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing segmentation algorithms"
)

=== debian/changelog ===
camitk (3.2.2-2) unstable; urgency=medium

  * debian/control:
     - cme fix dpkg-control
     - canonical Vcs fields
  * debian/rules:
     s/CMAKE_BUILD_TYPE:STRING=RelWithDebInfo/CMAKE_BUILD_TYPE:STRING=None/
    Closes: #711515

 -- Andreas Tille <tille@debian.org>  Mon, 16 Dec 2013 15:35:44 +0100

camitk (3.2.2-1) unstable; urgency=low

  * New upstream release.
      - Patches removed (merged in upstream)
  * Removed QCustomPlot (licence was not compatible, FTBS on armel and armhf)
  * camitk-imp description is now "workbench" (flagship was not really nice)
  * Remove uneeded dependencies (see #714935)
  * Updated pixmaps and desktop installation
  * Disable parallel build (that generates a "out of memory" error on some 
    plateforms when compiling itk filters)
  * Updated dev dependencies

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Fri, 19 Jul 2013 11:39:38 +0200

=== debian/control ===
Source: camitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Emmanuel Promayon <Emmanuel.Promayon@imag.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libvtk5-dev (>= 5.8),
               libqt4-dev,
               libvtk5-qt4-dev (>= 5.8),
               xsdcxx,
               libinsighttoolkit3-dev (>= 3.20),
               libxerces-c-dev,
               libxml2-dev,
               libgdcm2-dev,
               libfftw3-dev,
               libqtwebkit-dev | libqt4-dev (<< 4.7),
               libvtkgdcm2-dev
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/camitk/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/camitk/trunk/
Homepage: http://camitk.imag.fr/
X-Homepage: https://forge.imag.fr/projects/camitk/

Package: libcamitk3
Architecture: any
Depends: libqtpropertybrowser3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: libcamitk3-dev
Architecture: any
Section: libdevel
Depends: libcamitk3 (= ${binary:Version}),
         libqtpropertybrowser3-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: camitk-imp
Suggests: camitk-actionstatemachine
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard to create new extensions.

Package: libcamitk3-data
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the example and test data for CamiTK.

Package: libcamitk3-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations. 
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: camitk-actionstatemachine
Description: workbench application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-imp
Description: pipeline replay application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK 
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow to replay interactive the described state-machine containing a list
 of CamiTK actions and transitions.

Package: libqtpropertybrowser3
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser3.

Package: libqtpropertybrowser3-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for 
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# CamiTK version
VER_MAJOR=3
VER_MINOR=2
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_dev = libcamitk$(VER_MAJOR)-dev
pkg_qpb_dev = libqtpropertybrowser$(VER_MAJOR)-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine

# dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
# for component extensions:
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/components/
# for action extensions: 
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/actions/
# for private libraries:
LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-DCMAKE_BUILD_TYPE:STRING=None \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	\
	-DAPIDOC_SDK:BOOL=TRUE \
	\
	-DCAMITK_DICOM_INCOMPLETE_SUPPORT:BOOL=ON 

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	$(MAKE) -C obj-* apidoc
	# remove the javascript search field
	rm -f obj-*/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so.*
	# camitk-config is part of libcamitk
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
	dh_installman -p$(pkg_lib) debian/tmp/usr/share/man/man1/camitk-config.1  

	# separate tools qtpropertybrowser
	dh_install -p$(pkg_qpb) debian/tmp/usr/lib/libqtpropertybrowser.so.* usr/lib

	# camitk so and headers and static libs + wizard
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/coreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/pml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/lml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/mml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoring
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoringgui
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake 
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/launcher-templates/*.in
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-wizard
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/applications/camitk-wizard.desktop
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/pixmaps/camitk-wizard.xpm
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1

        # qtpropertybrowser so and headers (includes are put directly in usr/include as package should be generic/independant from CamiTK)
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/qtpropertybrowser usr/include

	# api doc
	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

	# all test data
	dh_install -p$(pkg_data) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/testdata

	# imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/bin/camitk-imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/share/applications/camitk-imp.desktop
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/share/pixmaps/camitk-imp.xpm
	dh_installman -p$(pkg_imp) debian/tmp/usr/share/man/man1/camitk-imp.1

	# asm
	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/bin/camitk-actionstatemachine
	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/share/pixmaps/camitk-actionstatemachine.xpm
	dh_installman -p$(pkg_asm) debian/tmp/usr/share/man/man1/camitk-actionstatemachine.1

override_dh_builddeb:
	dh_builddeb -- -Z xz

# see http://lists.debian.org/debian-mentors/2012/07/msg00124.html
get-orig-source:
	mkdir -p ../tarballs
	PERL_LWP_SSL_VERIFY_HOSTNAME=0 uscan --rename --verbose --force-download --destdir=../tarballs

## camitk 3.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,15 @@
 
 project(camitkopensource)
 
+# Allow testing of the whole camitk-opensource project
+include(CTest)
+enable_testing()
+
 # Specific to SDK: control the version (major, minor, default patch and )
 set(CAMITK_PROJECT_NAME "CamiTK")
 set(CAMITK_VERSION_MAJOR "3")
-set(CAMITK_VERSION_MINOR "2")
-set(CAMITK_VER_NICKNAME "azure") # blue, sapphire, *azure*, indigo, iris, Teal, cyan, turquoise, denim, celeste, zaffre, glaucous, ultramarine, cerulean
+set(CAMITK_VERSION_MINOR "3")
+set(CAMITK_VER_NICKNAME "indigo") # blue, sapphire, azure, *indigo*, iris, Teal, cyan, turquoise, denim, celeste, zaffre, glaucous, ultramarine, cerulean
 set(CAMITK_VERSION_PATCH "2") # patch version for packaging, change when appropriate
 string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)
 
@@ -25,6 +29,7 @@
 # Configure CamiTK Opensource packaging.
 # Must be done before parsing extensions CMakeLists.txt files.
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros)
+set(CAMITK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 include(CamiTKOpenSourcePackaging)
 camitk_opensource_packaging()
 
@@ -35,4 +40,14 @@
 add_subdirectory(imaging)
 add_subdirectory(modeling)
 
+# Do we wrapp CamiTK for scripting it into Python using Shiboken and PySide ?
+set(CAMITK_BINDING_PYTHON CACHE BOOL FALSE)
+
+# Consider python binding only if the CMake variable is checked
+if(CAMITK_BINDING_PYTHON)
+    add_subdirectory(python_sdk)
+endif()
+
+
+
 camitk_sub_project_validate(CEP_SET)

=== sdk/CMakeLists.txt ===
#--------------------------------------------
#         CamiTK Extension Project
#
# You should probably NOT modify this file...
# Please edit CEPDescription.cmake instead
#--------------------------------------------

cmake_minimum_required(VERSION 2.6)

include(SDKConfig.cmake) 

# Please add your project name inside the project() brackets, e.g. project(myProject)
project(${CEP_NAME})

# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# include global install of SDK
# This is a SDK build => global install is done in CMAKE_INSTALL_PREFIX
add_custom_target(sdk_global_install
    COMMAND ${CMAKE_COMMAND} -E echo "Global Installation in ${CMAKE_INSTALL_PREFIX}"
    # First remove the WIN32 system runtime libraries dependencies
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."
    # Second cmake to install
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} -E echo "Global installation in ${CMAKE_INSTALL_PREFIX} done."
    COMMENT "Global installation"
)

# The definition of SDK_TOP_LEVEL_SOURCE_DIR and SDK_TOP_LEVEL_BINARY_DIR are
# are needed to store the current source dir to pass as an argument to the ConfigureCamiTKDirTxt.cmake script in sdk_copy_camitkdirtxt
set(SDK_TOP_LEVEL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SDK_TOP_LEVEL_BINARY_DIR ${CMAKE_BINARY_DIR})
# specific top-level target that prepare and copy the CamiTKDir.txt file in ${CAMITK_USER_DIR}
add_custom_target(sdk_copy_camitkdirtxt
    # prepare the CamiTKConfig.cmake for installation
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
                             -DCAMITK_USER_DIR=${CAMITK_USER_DIR}
                             -DSDK_TOP_LEVEL_SOURCE_DIR=${SDK_TOP_LEVEL_SOURCE_DIR}
                             -DSDK_TOP_LEVEL_BINARY_DIR=${SDK_TOP_LEVEL_BINARY_DIR}
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/ConfigureCamiTKDirTxt.cmake
    # Make sure the user dir exists
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CAMITK_USER_DIR}"
    # Remove the previous version
    COMMAND ${CMAKE_COMMAND} -E remove -f ${CAMITK_USER_DIR}/CamiTKDir.txt
    # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "CamiTKDir.txt [${CMAKE_INSTALL_PREFIX}] copied in ${CAMITK_USER_DIR}"
)

# camitk_local_install == install in User Config directory
add_custom_target(sdk_local_install
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR}"
    # First cmake to redefine install prefix
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CAMITK_USER_DIR} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."    
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR} done."
    COMMENT "Local installation"
)

# make sure a copy of the CamiTKDir.txt file is written to ${CAMITK_USER_DIR}
# even if the user is just invoking the "install" target (from the IDE or command line)
install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target sdk_copy_camitkdirtxt)")

# include CamiTK auto-documentation generation
include(CamiTKApiDoc)

# initialize subproject management
camitk_sub_project_init()

# Create a shiboken path variable containing the CamiTK SDK tree structure, needed by shiboken to find C++ classes to wrap
set(SHIBOKEN_CAMITK_SDK_PATH ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# add all subprojects
camitk_add_subdirectory(libraries)
camitk_add_subdirectory(applications)
camitk_add_subdirectory(components)
camitk_add_subdirectory(actions)
camitk_add_subdirectory(viewers)
add_subdirectory(cmake) # for cmake module installation

# Validate project.xml file for CDash
camitk_sub_project_validate()



message(STATUS "compiling in ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CFG_INTDIR=${CMAKE_CFG_INTDIR}")
message(STATUS "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}")

=== imaging/components/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
     add_subdirectory(dicomdirectory)
     add_subdirectory(dicomimage)
 else()
-    message(WARNING "CAMITK_DICOM_INCOMPLETE_SUPPORT: This configuration uses the legacy dicom component (directly based on ITK). The CamiTK recommands using the new dicomdirectory and dicomimage components (which require/depend on GDCM library)")
+    message(WARNING "CAMITK_DICOM_INCOMPLETE_SUPPORT: This configuration uses the legacy dicom component (directly based on ITK). The CamiTK team recommends using the new dicomdirectory and dicomimage components (which require/depend on GDCM library version 2)")
     add_subdirectory(dicom)
 endif()

=== sdk/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro apropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  add_subdirectory(${ACTION_NAME})
endforeach()

=== sdk/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro apropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)

# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 

# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   add_subdirectory(${APPLICATION_NAME})
endforeach()

=== sdk/components/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,9 @@
 # find components
 get_subdirectories(COMPONENTS_LIST)
 
+# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
+set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 
+
 # Add subdirectories in CMake project
 foreach(COMPONENT_NAME ${COMPONENTS_LIST})
   add_subdirectory(${COMPONENT_NAME})

=== sdk/doc/CMakeLists.txt ===

add_subdirectory(resources/actions)

=== sdk/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro apropriately

# Find applications
get_subdirectories(LIBRARY_LIST)

# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 

# --- add every given library
foreach(LIB_NAME ${LIBRARY_LIST})
   add_subdirectory(${LIB_NAME})
endforeach()

=== imaging/actions/itkfilters/CMakeLists.txt ===
if (WIN32)
    if(CMAKE_CL_64)
        # for 64 bits platform, enable big obj (.o) handling, in ordere to correctly compile this (heavy) project
        if (MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}/bigobj")
            elseif(MINGW)
                set(CMAKE_CXX_FLAGS "-O3 -finline-functions")
            endif()
    endif()
endif()

camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    CXX_FLAGS "-w"
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing filters"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
)

=== imaging/actions/itksegmentation/CMakeLists.txt ===
camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    NEEDS_ACTION_EXTENSION multipicking
                    CEP_NAME CEP_IMAGING
                    CXX_FLAGS "-w"
                    DESCRIPTION "This action features basic ITK image processing segmentation algorithms"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
)

=== imaging/components/dicom/CMakeLists.txt ===
# dicom component just needs to use the component_extension macro
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_ITK
                    CEP_NAME CEP_IMAGING
                    CXX_FLAGS "-w"
                    DESCRIPTION  "This component allows the handling of DICOM images using GDCM 2.2"
                    DEFINES _SCL_SECURE_NO_WARNINGS _CRT_SECURE_NO_WARNINGS #to remove warning on Windows platform
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
)

=== imaging/components/dicomdirectory/CMakeLists.txt ===
camitk_extension(   COMPONENT_EXTENSION
                    DISABLED
                    NEEDS_GDCM
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This component allows to read several image files from a directory using the library GDCM 2.2.x"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
)

=== debian/changelog ===
camitk (3.3.2-2) unstable; urgency=medium

  * Fix autopkgtest for 3.3.2  
    Closes: #758130

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Tue, 23 Sep 2014 11:25:42 +0200

camitk (3.3.2-1) unstable; urgency=low

  * New upstream release. 
  * Patches:
    - avoid console redirection (config-console-redirection.diff)
    - missing manpages, desktop and icon (applications-man-pixmap-desktop.diff)
    - remove non-dfsg compliant flash video player
  * Added some package tests
  * Added some debian/tests files for autopkgtest
  * New dicom components now directly based on gdcm 

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Tue, 06 May 2014 11:06:00 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,10 @@
                libgdcm2-dev,
                libfftw3-dev,
                libqtwebkit-dev | libqt4-dev (<< 4.7),
-               libvtkgdcm2-dev
+               libvtkgdcm2-dev,
+               libqt4-opengl-dev,
+               xvfb,
+               xauth
 Build-Depends-Indep: doxygen,
                      graphviz
 Standards-Version: 3.9.5
@@ -24,6 +27,7 @@
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/camitk/trunk/
 Homepage: http://camitk.imag.fr/
 X-Homepage: https://forge.imag.fr/projects/camitk/
+Testsuite: autopkgtest
 
 Package: libcamitk3
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,11 @@
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-# CamiTK version
-VER_MAJOR=3
-VER_MINOR=2
+# CamiTK version from d/changelog)
+CHANGELOG_VERSION := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
+FULL_VERSION := $(shell echo '$(CHANGELOG_VERSION)' | sed -e 's/^[[:digit:]]*://' -e 's/[~-].*//')
+VER_MAJOR := $(shell echo '$(FULL_VERSION)' | cut -f1 -d".")
+VER_MINOR := $(shell echo '$(FULL_VERSION)' | cut -f2 -d".")
 VER_SHORT=$(VER_MAJOR).$(VER_MINOR)
 
 # package aliases (see d/control)
@@ -21,19 +23,26 @@
 
 # dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
 # between extensions (i.e., mml component extension depends on physicalmodel component extensions)
+PKG_LIB_DIR := $(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}
 # for component extensions:
-LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/components/
+LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/components/
 # for action extensions: 
-LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/actions/
+LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/actions/
 # for private libraries:
-LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}/
+LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/
+# during test, the build dir path is also needed
+LIB_BUILD_DIR := $(CURDIR)/camitk-build/lib
+PRIVATE_LIB_BUILD_DIR := $(LIB_BUILD_DIR)/camitk-${VER_SHORT}
+LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_BUILD_DIR):$(PRIVATE_LIB_BUILD_DIR)/components/:$(PRIVATE_LIB_BUILD_DIR)/actions/:$(PRIVATE_LIB_BUILD_DIR)/
+# export for all d/rules subshell (test and dpkg-shlibdeps included)
+export LD_LIBRARY_PATH
 
 # CMake flags are of two types:
 # - generic (to tell cmake to build proper binaries)
 # - CamiTK specific options
 CMAKE_EXTRA_FLAGS = \
-	-DCMAKE_SKIP_RPATH:BOOL=ON \
-	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
+	-DCMAKE_SKIP_RPATH:BOOL=TRUE \
+	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=FALSE \
 	-DCMAKE_BUILD_TYPE:STRING=None \
 	\
 	-DCEP_IMAGING:BOOL=TRUE \
@@ -41,23 +50,44 @@
 	\
 	-DAPIDOC_SDK:BOOL=TRUE \
 	\
-	-DCAMITK_DICOM_INCOMPLETE_SUPPORT:BOOL=ON 
+	-DCAMITK_DICOM_INCOMPLETE_SUPPORT:BOOL=FALSE \
+	-DCOMPONENT_DICOMDIRECTORY=TRUE \
+	-DCOMPONENT_DICOMIMAGE=TRUE
 
 %:
-	dh $@
+	# For debian buildd, do not authorize parallel build (too much RAM needed for Imaging CEP)
+	dh $@ --builddirectory=camitk-build
+	# For local personal build, parallel is ok as there is enough RAM for heavy-templated Imaging CEP
+	#dh $@ --parallel --builddirectory=camitk-build  
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
 # let's be smart with doc
 override_dh_auto_build-indep:
-	$(MAKE) -C obj-* apidoc
+	$(MAKE) -C camitk-build apidoc
 	# remove the javascript search field
-	rm -f obj-*/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js
+	rm -f camitk-build/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js
 
 # No tests needed for docs
 override_dh_auto_test-indep:
 
+# a selection of relevant tests
+override_dh_auto_test:
+	# the CamiTK test suite is not 100% relevant yet
+	# Use only some of the tests (basically the one that
+	# pass out of the box in CamiTK 3.3)
+	# Note: all tests require an X server, xvfb-run is needed to have a virtual one
+	# Component extension tests
+	ldd -r camitk-build/bin/camitk-testcomponents || echo "ok"
+	# Another way: xvfb-run --auto-servernum $(MAKE) -C camitk-build ARGS="-V -I 1,1,,1,...etc..." test
+	(cd camitk-build && xvfb-run --auto-servernum ctest -V -I 1,1,,1 --timeout 300)
+	# Action extensions tests (100% coverage here)
+	(cd camitk-build && xvfb-run --auto-servernum ctest -V -I 20,20,,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35 --timeout 300)
+	# Standalone lib test (0% coverage)
+	# TODO remove this override when tests are relevant (hopefully for the next upstream version)
+
+# make packages
 override_dh_install:
 	# $(CURDIR) is the current source dir
 	# camitk dynamic library
@@ -70,10 +100,11 @@
 	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
 	dh_installman -p$(pkg_lib) debian/tmp/usr/share/man/man1/camitk-config.1  
 
-	# separate tools qtpropertybrowser
+	# separate packaging for qtpropertybrowser (can be used independently from camitk)
 	dh_install -p$(pkg_qpb) debian/tmp/usr/lib/libqtpropertybrowser.so.* usr/lib
 
-	# camitk so and headers and static libs + wizard
+	# camitk developer package
+	# camitk so and headers and static libs 
 	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib 
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.so
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
@@ -91,10 +122,19 @@
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake 
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake 
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/launcher-templates/*.in
+	# wizard
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-wizard
+	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/applications/camitk-wizard.desktop
 	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/pixmaps/camitk-wizard.xpm
-	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1
+	# cepgenerator
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-cepgenerator
+	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-cepgenerator.1
+	# test programs
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testactions
+	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testactions.1
+	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testcomponents
+	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testcomponents.1
 
         # qtpropertybrowser so and headers (includes are put directly in usr/include as package should be generic/independant from CamiTK)
 	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
@@ -114,13 +154,3 @@
 
 	# asm
 	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/bin/camitk-actionstatemachine
-	dh_install -p$(pkg_asm) --autodest debian/tmp/usr/share/pixmaps/camitk-actionstatemachine.xpm
-	dh_installman -p$(pkg_asm) debian/tmp/usr/share/man/man1/camitk-actionstatemachine.1
-
-override_dh_builddeb:
-	dh_builddeb -- -Z xz
-
-# see http://lists.debian.org/debian-mentors/2012/07/msg00124.html
-get-orig-source:
-	mkdir -p ../tarballs
-	PERL_LWP_SSL_VERIFY_HOSTNAME=0 uscan --rename --verbose --force-download --destdir=../tarballs
